

/*
Stand 06.01.2019 *
*ERMER Christof**
REGENSBURG
*/

/* 
Diese Datei dient zum einfachen Auffinden und Zufgen der Befehle.
Deshalb wurden die Befehle in diese Datei ausgelagert.

BEFEHLE 
Befelsform:
Kommando,u16Val1,u16Val2<13>
Bsp:
Motor,123,34<CR>
Ping<CR>
*/

#include "main.h"

/*
EIne Besonderheit des AVR Mikrocontrollers ist die unterschiedliche Behandlung von Zeichen=Strings, 
die entweder im Flash-Speicher  Stehen, und somit von dort gelesen werden,
oder die im RAM stehen,
Es gibt also also C-Funktionen die Strings behandeln doppelt.
einmal mit "Programm Memory Handling" und
quasi Normal: ohne besonderen, dafr RAM-Verbrauchende Stringbehandlung.

Hier liegt musterglitig ein "const cahr" string , d
der aber im "Programm-Flash" abgespeichert wird und nicht im "RAM".
*/

//	\r return
//	\r\n return, line fedd
//	\r\n \t  return, line fedd, tabulator

//Prototype
// GLOBALE VARIABLEN
// CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
// const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
#ifdef UART_USE_ENABLED
char gcaStr[STRMAX + 1]; //+1 for the 0
char gcaNumStr[NUMMAX + 1]; //+1 for the 0

char* gpcRxPars;
char gcaRxStr[ RX_STRMAX + 1]; //+1 for the 0
COMMAND_TYPE gsCmd; // Hier liegen die Befehle und Parameter ab

// *********************************
void CheckOrder(void) //von gcaRxStr
// *********************************
{ //Input von der Seriellen Schnittstlle, in der Form:  "BEFEHL,WERT" BSP: "SFR,1000"
//========================
TokensRXStr(gcaRxStr);
//========================
ResetRxBuff();
//========================
 
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )
	{	
	uart_puts_p( PSTR("\r\nPONG") );	
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DEVICE")))  // GET
	{
	uart_puts_p( PSTR("\r\nLED_7x8 Array") );
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("TT"))) //TICKS anzeigen
	{
	uart_putc( 13 ); //CR
	uart_putc( 10 ); //LF
	uart_puts_p( PSTR("Tick:") );
	uart_puts( ultoa( gu32_Ticks, gcaNumStr, 10 ) );
	return;	
	};


if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("HH"))) //TICKS anzeigen
	{
	OCR0A = gsCmd.i16CmdVal_1;
	uart_putc( 13 ); //CR
	uart_putc( 10 ); //LF
	uart_puts_p( PSTR("PWM:") );
	uart_puts( ultoa( OCR0A, gcaNumStr, 10 ) );	
	return;	
	};



/*
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("")))
	{
	return;
	};
*/	
 }; // ORDER


// **************************
void ResetRxBuff(void)
// **************************
{
uart_flush();
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
gu8StatusFlags &= ~ORDER_FLAG;
};

//Funktionen Definition
// *******************************************************************
void UART_RX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
if( gu8StatusFlags & ORDER_FLAG ) // Nichts mehr aktzeptieren!!
	{
	return;
	};
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
//#define USE_ERROR_MSG
#ifdef USE_ERROR_MSG
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		uart_puts_p( PSTR("UartErr\r") );
		};
#endif
//NOW SELECT ACTION FROM ORDER
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 10: // LF raus=nix machen
				{				
				break;
				};	           				
			case 13: ////Check CR order
				{
				gu8StatusFlags |= ORDER_FLAG;  // Auslagern wegen InterruptZeit
				//CheckOrder( gcaRxStr );//gcaRxStr = accumulated str
				//ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with  Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x00FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				break;
				};
			};//switch
		}
	else  // To much data Rx, than clear simple all
		{//overflow of RX clears all
		ResetRxBuff();
		};
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};

/* Diese Funktion zerlegt den Befehls-String in einzelne Module */
// *******************************************************************
void TokensRXStr(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
const char  caDelimiter[]= ",";
char * pStrTok; // fr strtok_r
//char * pcCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*
//char * 	strtok_r (char *, const char *, char **)
//char * 	strtok (char *, const char *)
//if( (pStrTok = strtok_r( pcStrOrder, caDelimiter , &pcCh)) != NULL) // Trenne 1.Token in Command
if( (pStrTok = strtok( pcStrOrder, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

//fr 2 fVal Variablen nach dem Kommand
gsCmd.i16CmdVal_1 = 0;
gsCmd.i16CmdVal_2 = 0;
//HIER NULL POINTER
if( (pStrTok = strtok( NULL, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{
	//gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_1 = atoi(pStrTok);
	};
//HIER NULL POINTER
if( (pStrTok = strtok( NULL, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{
//	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_2 = atoi(pStrTok);
	};	
};

#endif

